package filebookmark.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;

import filebookmark.model.Bookmark;
import filebookmark.util.ElementType;
import filebookmark.view.BookmarkView;

public class SortAction implements IViewActionDelegate {

	private BookmarkView view;

	
	public void init(IViewPart view) {
		this.view = (BookmarkView)view;
	}

	public void run(IAction action) {
        TreeViewer viewer = (TreeViewer)view.getSite().getSelectionProvider();	
		if(action.isChecked()){
			viewer.setSorter(new NameSorter());
		}else{
			viewer.setSorter(null);
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
	}

	class NameSorter extends ViewerSorter{
		public int category(Object element) {
			if(((Bookmark) element).getType() == ElementType.CATEGORY){
				return 0;
			}
			return 1;
		}
	}
}
